#include <PID_v1.h>
#include <Arduino.h>

#define MoteurGEncoderA 2
#define MoteurGEncoderB 9
#define MoteurGE_left 5
#define MoteurGM_left 4


class MoteurEncodeur {
    private: 
        bool direction;
        int duration;
        int result;
        int E_left, M_left;
        int encoder0pinA, encoder0pinB;
        byte encoder0PinALast;
        double duration,abs_duration;//the number of the pulses
        double val_output;//Power supplied to the motor PWM value.
        double Setpoint;
        double Kp=0.6, Ki=5, Kd=0;
        PID myPID;

    public:
        void advance()//Motor Forward
        {
            digitalWrite(M_left,LOW);
            analogWrite(E_left,val_output);
        }
        void wheelSpeed()
        {
            int Lstate = digitalRead(encoder0pinA);
            if((encoder0PinALast == LOW) && Lstate==HIGH)
            {
                int val = digitalRead(encoder0pinB);
                if(val == LOW && direction)
                {
                direction = false; //Reverse
                }
                else if(val == HIGH && !direction)
                {
                direction = true;  //Forward
                }
            }
            encoder0PinALast = Lstate;

            if(!direction)  duration++;
            else  duration--;
        }

        int get_interuptPin() {
            return digitalPinToInterrupt(encoder0pinA);
        };

        MoteurEncodeur(int encoder0pinA, int encoder0pinB, int E_left, int M_left) {
            this->encoder0pinA = encoder0pinA;
            this->encoder0pinB = encoder0pinB;
            this->E_left = E_left;
            this->M_left = M_left;
            this->direction = true;
            PID myPID(&abs_duration, &val_output, &Setpoint, Kp, Ki, Kd, DIRECT);
            Serial.begin(9600);//Initialize the serial port
            pinMode(M_left, OUTPUT);   //L298P Control port settings DC motor driver board for the output mode
            pinMode(E_left, OUTPUT);
            Setpoint =80;  //Set the output value of the PID
            myPID.SetMode(AUTOMATIC);//PID is set to automatic mode
            myPID.SetSampleTime(100);//Set PID sampling frequency is 100ms
            pinMode(encoder0pinB,INPUT);
        }
};

MoteurEncodeur moteurGauche;

void MG_wheelSpeed() {
    moteurGauche.wheelSpeed();
}

void setup() {
    MoteurEncodeur moteurGauche(MoteurGEncoderA,MoteurGEncoderB,MoteurGE_left,MoteurGM_left);
    attachInterrupt(moteurGauche.get_interuptPin(), MG_wheelSpeed, CHANGE);
}